<?php
if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

/**
 * fonction pour les remplacements génériques fournis par gamumail
 *
 * @param array $args = ['slug' => $slug, 'destinataires' => $pour, [$options]]
 * @param string $data = $html
 *
 * @return $html
 *
 **/
function inc_gamumail_remplacements_dist($args, $html) {
	/**
	 * @@url_spip_pass@@
	 * ATTENTION, il ne faut passer QUE si  @@url_spip_pass@@ est présent, car la fonction
	 * auteur_attribuer_jeton ne peut etre appeler qu'une fois, du mois, il faut utilser le jeton de son dernier appel.
	 **/
	if (strpos($html, '@@url_spip_pass@@') !== false) {
		$url_spip_pass = '';
		if (!empty($args['destinataires'][0])) {
			$id_auteur = (int) sql_getfetsel('id_auteur', 'spip_auteurs', 'email='.sql_quote($args['destinataires'][0]));
			include_spip('action/inscrire_auteur');
			$cookie = auteur_attribuer_jeton($id_auteur);
			$url_spip_pass = url_absolue(
						generer_url_public('spip_pass', "p=$cookie"),
						$GLOBALS['meta']['adresse_site'] . '/'
					);
		}
		$html = gamumail_remplacer_modele('url_spip_pass', $url_spip_pass, $html);
	}

	/**
	 * @@nom@@ => $nom ou un espace pour vider le champ @@nom@@
	 **/
	$nom = sql_getfetsel('nom', 'spip_auteurs', 'email='.sql_quote($args['destinataires'][0])) ?? ' ';
	$html = gamumail_remplacer_modele('nom', ucwords($nom), $html);

	/**
	 * @@prenom@@ => $prenom ou un espace pour vider le champ @@prenom@@
	 **/
	$prenom = ' ';
	$trouver_table = charger_fonction('trouver_table', 'base');
	$desc = $trouver_table('spip_auteurs');
	if (array_key_exists('prenom', $desc['field'])) {
		$prenom = sql_getfetsel('prenom', 'spip_auteurs', 'email='.sql_quote($args['destinataires'][0])) ?? ' ';
	}
	$html = gamumail_remplacer_modele('prenom', ucwords($prenom), $html);

	/**
	 * @@url_site@@ => URL du site
	 **/
	$url_site = lire_config('adresse_site');
	$html = gamumail_remplacer_modele('url_site', $url_site, $html);

	/**
	 * @@nom_site@@ => nom du site
	 **/
	$nom_site = lire_config('nom_site');
	$html = gamumail_remplacer_modele('nom_site', $nom_site, $html);

	/**
	 * @@url_raz_passe@@ => URL de la page de récupération de mot de passe
	 **/
	$url_raz_passe = url_absolue(generer_url_public('spip_pass'));
	$html = gamumail_remplacer_modele('url_raz_passe', $url_raz_passe, $html);


	return $html;
}
